// toShare configuration.js
'use strict';
// uses rest, tooltip

const sectionConfiguration = document.querySelector('.configuration');
const tableConfiguration = sectionConfiguration.querySelector('table');
const tbodyConfiguration = sectionConfiguration.querySelector('tbody');
const trTemplateConfiguration = tbodyConfiguration.firstElementChild.cloneNode(true);
const divEditLayer = document.querySelector('div.edit-layer');
const buttonCancel = divEditLayer.querySelector('button.cancel');
const labelConfigItem = divEditLayer.querySelector('label.config-item');
const inputConfigValue = divEditLayer.querySelector('input.config-value');
const buttonFix = divEditLayer.querySelector('button.fix');

const linkCssStyle = document.createElement('link');
linkCssStyle.rel = 'stylesheet';
linkCssStyle.type = 'text/css';
document.head.appendChild(linkCssStyle);

function updateConfigurationList(){
	const items = ['Color style', 'Account Placeholder'];
	atsConfiguration.restGet(items).then(()=>{
		tbodyConfiguration.innerHTML = '';
		for(const atsConfig of atsConfiguration.data){
			const trTable = trTemplateConfiguration.cloneNode(true);
			const td = trTable.querySelectorAll('td');
			td[0].innerText = atsConfig.item;
			td[1].innerText = atsConfig.value;
			trTable.addEventListener('click', onTrConfigurationClick);
			tbodyConfiguration.appendChild(trTable);
		}
		const cssFileName = atsConfiguration.valueFromKey('Color style')
		const cssFileUrl = `${location.origin}/ats/${cssFileName}.css`;
		linkCssStyle.href = cssFileUrl;
	})
}
function onResize(){
	const remPx = parseFloat(getComputedStyle(document.documentElement).fontSize);
	const viewHeight = window.innerHeight;
	const conteinerTop = sectionConfiguration.getBoundingClientRect().top;
	const containerHeight = viewHeight - conteinerTop - 6 * remPx;
	tableConfiguration.style.maxHeight = containerHeight + 'px';
}
function onTrConfigurationClick(event){
	if((event.target.tagName != 'A')&(!event.currentTarget.classList.contains('current'))){
		for(const tbodyTr of tbodyConfiguration.querySelectorAll('tr')){
			if(tbodyTr.classList.contains('current')){tbodyTr.classList.remove('current');}
		}
		event.currentTarget.classList.add('current');
		divEditLayer.style.display = 'block';
		event.preventDefault();
		const atsConfig = atsConfiguration.findField('item', event.currentTarget.children[0].innerText);
		labelConfigItem.innerText = atsConfig.item;
		inputConfigValue.value = atsConfig.value;
		inputConfigValue.select();
		inputConfigValue.focus();
		buttonFix.disabled = true;
	}else{
		event.currentTarget.classList.remove('current');
		divEditLayer.style.display = 'none';
	}
}
function onOutsideClick(event){
	if(event.currentTarget===event.target){
		onCancel();
	}
}
function onCancel(){
	for(const tbodyTr of tbodyConfiguration.querySelectorAll('tr')){
		if(tbodyTr.classList.contains('current')){tbodyTr.classList.remove('current');}
	}
	divEditLayer.style.display = 'none';
}
function onTableModified(){
		buttonFix.disabled = false;
}
async function onExecute(event){

	await atsConfiguration.restPut(
		labelConfigItem.innerText,
		inputConfigValue.value
	);
	divEditLayer.style.display = 'none';
	updateConfigurationList();
}

tbodyConfiguration.innerHTML = '';
updateConfigurationList();
window.addEventListener( 'resize', onResize);
divEditLayer.addEventListener('click', onOutsideClick);
buttonCancel.addEventListener('click', onCancel);
inputConfigValue.addEventListener('input', onTableModified);
buttonFix.addEventListener('click', onExecute);
onResize();
